Grantlee: Grantlee Namespace Reference

Grantlee 5.3.0

Classes | Enumerations | Functions
Grantlee Namespace Reference

The Grantlee namespace holds all public Grantlee API.

## Classes
class | AbstractLocalizer
| Interface for implementing an internationalization system. More...
class | AbstractMarkupBuilder
| Interface for creating marked-up text output. More...
class | AbstractNodeFactory
| Base class for all NodeFactories. More...
class | AbstractTemplateLoader
| An retrieval interface to a storage location for Template objects. More...
class | BBCodeBuilder
| Builder to create BBCode from a QTextDocument. More...
class | CachingLoaderDecorator
| Implements a loader decorator which caches compiled Template objects. More...
class | Context
| The Context class holds the context to render a Template with. More...
class | Engine
| Grantlee::Engine is the main entry point for creating Grantlee Templates. More...
class | Exception
| An exception for use when implementing template tags. More...
class | FileSystemTemplateLoader
| The FileSystemTemplateLoader loads Templates from the file system. More...
class | Filter
| Base class for all filters. More...
class | FilterExpression
| A FilterExpression object represents a filter expression in a template. More...
class | InMemoryTemplateLoader
| The InMemoryTemplateLoader loads Templates set dynamically in memory. More...
class | MarkupDirector
| Instructs a builder object to create markup output. More...
class | MediaWikiMarkupBuilder
| Creates MediaWiki markup from a QTextDocument. More...
class | Node
| Base class for all nodes. More...
class | NodeList
| A list of Nodes with some convenience API for rendering them. More...
class | OutputStream
| The OutputStream class is used to render templates to a QTextStream. More...
class | Parser
| The Parser class processes a string template into a tree of nodes. More...
class | PlainTextMarkupBuilder
| Creates a simple marked up plain text document. More...
class | QtLocalizer
| Provides internationalization based on QLocale and QTranslator. More...
class | RenderContext
| Provides storage facility for state while rendering a template. More...
class | SafeString
| A QString wrapper class for containing whether a string is safe or needs to be escaped. More...
class | TagLibraryInterface
| The TagLibraryInterface returns available tags and filters from libraries. More...
class | Template
| The Template class is a tree of nodes which may be rendered. More...
class | TextHTMLBuilder
| The TextHTMLBuilder creates a clean html markup output. More...
struct | Token
class | Variable
| A container for static variables defined in Templates. More...

## Enumerations
enum | Error { NoError , EmptyVariableError , EmptyBlockTagError , InvalidBlockTagError , UnclosedBlockTagError , UnknownFilterError , TagSyntaxError , VariableNotInContext , ObjectReturnTypeInvalid , CompileFunctionError }
enum | TokenType { TextToken , VariableToken , BlockToken , CommentToken }

## Functions
std::pair< qreal, QString > | calcFileSize (qreal size, int unitSystem=10, qreal multiplier=1.0)
bool | equals (const QVariant &lhs, const QVariant &rhs)
Grantlee::SafeString | getSafeString (const QVariant &input)
bool | isSafeString (const QVariant &input)
Grantlee::SafeString | markForEscaping (const Grantlee::SafeString &input)
Grantlee::SafeString | markSafe (const Grantlee::SafeString &input)
template<typename RealType , typename HandleAs >
int | registerMetaType ()
| Registers the type RealType with the metatype system.
bool | supportedOutputType (const QVariant &input)
QString | unescapeStringLiteral (const QString &input)
bool | variantIsTrue (const QVariant &variant)

## Enumeration Type Documentation

## ◆ Error

enum Grantlee::Error

Types of errors that can occur while using Grantlee

Definition at line 36 of file exception.h.

## ◆ TokenType

enum Grantlee::TokenType

The available token types.

Enumerator
TextToken | The Token is a text fragment.
VariableToken | The Token is a variable node.
BlockToken | The Token is a block, ie, part of a tag.
CommentToken | The Token is a comment node.

Definition at line 34 of file token.h.

## Function Documentation

## ◆ calcFileSize()

std::pair< qreal, QString > Grantlee::calcFileSize | ( | qreal | size,
|  | int | unitSystem = 10,
|  | qreal | multiplier = 1.0 )

Converts `size` into the nearest file size unit like MB or MiB, based on the `unitSystem` value. Use `2` for the `unitSystem` to get binary units, use `10` to get decimal units - by default, decimal units will be returned. The `multiplier` can be used if the input `size` is not in pure bytes. If `size` is for example given in KiB, use a multiplier of 1024. The returned pair will have the converted size as first and the unit as second.

## ◆ equals()

bool Grantlee::equals | ( | const QVariant & | lhs,
|  | const QVariant & | rhs )

Compares `lhs` and `rhs` for equality. SafeStrings are compared as raw QStrings. Their safeness is not part of the comparison.

See also
  QVariant::operator==

## ◆ getSafeString()

Grantlee::SafeString Grantlee::getSafeString | ( | const QVariant & | input | ) |

Retrieves and returns a SafeString from the `input`.

## ◆ isSafeString()

bool Grantlee::isSafeString | ( | const QVariant & | input | ) |

Returns whether `input` contains a SafeString.

## ◆ markForEscaping()

Grantlee::SafeString Grantlee::markForEscaping | ( | const Grantlee::SafeString & | input | ) |

Marks the `input` as requiring escaping.

## ◆ markSafe()

Grantlee::SafeString Grantlee::markSafe | ( | const Grantlee::SafeString & | input | ) |

Marks the `input` as safe.

## ◆ registerMetaType()

template<typename RealType , typename HandleAs >

int Grantlee::registerMetaType | ( |  | ) |

This method can take a second template parameter to specify a cast that should be invoked during registration. This is useful if a base type is already supported.

class SomeType
{
public:
QString someProp() const;
};
// define some introspectable API for SomeType
GRANTLEE_BEGIN_LOOKUP(SomeType)
if (property == "someProp")
return object.someProp();
GRANTLEE_END_LOOKUP
class OtherType : public SomeType
{
// ...
};
registerMetaType<SomeType>();
// Only the introspectable API from SomeType is needed, so we can reuse that
registration.
registerMetaType<OtherType, SomeType>();
GRANTLEE_BEGIN_LOOKUP
#define GRANTLEE_BEGIN_LOOKUP(Type)
Definition metatype.h:213
GRANTLEE_END_LOOKUP
#define GRANTLEE_END_LOOKUP
Definition metatype.h:239
Grantlee::registerMetaType
int registerMetaType()
Registers the type RealType with the metatype system.
Definition metatype.h:182

See also
  Generic type and template support

Definition at line 182 of file metatype.h.

Referenced by Grantlee::NodeList::findChildren(), Grantlee::SafeString::get(), Grantlee::SafeString::get(), and Grantlee::SafeString::operator QString().

## ◆ supportedOutputType()

bool Grantlee::supportedOutputType | ( | const QVariant & | input | ) |

Returns true if the type of `input` can be inserted into a rendered template directly.

Note that lists, hashes and QObject*s can not be.

## ◆ unescapeStringLiteral()

QString Grantlee::unescapeStringLiteral | ( | const QString & | input | ) |

Converts the `input` into its unescaped form.

Double slashes are converted to single slashes, \&quot is converted to &quot etc.

## ◆ variantIsTrue()

bool Grantlee::variantIsTrue | ( | const QVariant & | variant | ) |

Returns whether the `variant` is evaluated to true.

See also
  Truthiness